#include <iostream>
#include <queue>

using namespace std;

int a[50][50];
int good[50][50];
int n;

struct cell
{
	int x, y;
	cell() {x = 0; y = 0;}
	cell(int _x, int _y) {x = _x; y = _y;}
};

int main()
{
    cin >> n;
    char c[50];
    
    cin.getline(c, 49);
    
    for (int i = 0; i < n; i++)
    {
        cin.getline(c, 49);
        for (int j = 0; j < n; j++)
        {
            if (c[j] == '.')
               a[i][j] = 1;
            else
                a[i][j] = 0;
        }    
    }
    for (int i = 0; i < n; i++)
    	for (int j = 0; j < n; j++)
    		good[i][j] = 0;
    
    queue<cell> q;
    q.push(cell(0, 0));
    q.push(cell(n-1, n-1));
    while (!q.empty())
    {
		cell curr = q.front();
		q.pop();
		good[curr.y][curr.x] = 1;
		
		if ((a[curr.y - 1][curr.x] == 1) && (!good[curr.y - 1][curr.x]))
		{
			//good[curr.y - 1][curr.x] = 1;
			q.push(cell(curr.x, curr.y - 1));
		}
		if ((a[curr.y + 1][curr.x] == 1) && (!good[curr.y + 1][curr.x]))
		{
			//good[curr.y + 1][curr.x] = 1;
			q.push(cell(curr.x, curr.y + 1));
		}
		if ((a[curr.y][curr.x - 1] == 1) && (!good[curr.y][curr.x - 1]))
		{
			//good[curr.y][curr.x - 1] = 1;
			q.push(cell(curr.x - 1, curr.y));
		}
		if ((a[curr.y][curr.x + 1] == 1) && (!good[curr.y][curr.x + 1]))
		{
			//good[curr.y][curr.x + 1] = 1;
			q.push(cell(curr.x + 1, curr.y));
		}
	}
	
	int area = 0;
	
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            if (!good[i][j])
            	continue;
            
        	if ((a[i - 1][j] == 0) || (i - 1 < 0))
			{
				if ((i != 0) || (j != 0))
					area++;
			}
			if ((a[i + 1][j] == 0) || (i + 1 >= n))
			{
				if ((i != n - 1) || (j != n - 1))
					area++;
			}
			if ((a[i][j - 1] == 0) || (j - 1 < 0))
			{
				if ((i != 0) || (j != 0))
					area++;
			}
			if ((a[i][j + 1] == 0) || (j + 1 >= n))
			{
				if ((i != n - 1) || (j != n - 1))
					area++;
			}
        }	
    }
    
    
    cout << area*9 << endl;
    
    /*for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
            cout << good[i][j];
            
        cout << endl;
    }*/
    return 0;
}
