#include <iostream>

using namespace std;

struct point
{
	int x, y;
	int n;
};

int compy(const void* a, const void* b)
{
	if (((point*)a)->y == ((point*)b)->y)
		return ((point*)a)->n > ((point*)b)->n ? 1 : 0;
	
	return ((point*)a)->y > ((point*)b)->y ? 1 : 0;
}

int compx(const void* a, const void* b)
{
	if (((point*)a)->x == ((point*)b)->x)
		return ((point*)a)->n > ((point*)b)->n ? 1 : 0;
	
	return ((point*)a)->x > ((point*)b)->x ? 1 : 0;
}

int main()
{
    
    int n;
    cin >> n;
    
    point tr[n];
    point x[n], y[n];
    int used[n];
    
    for (int i = 0; i < n; i++)
    {
		cin >> tr[i].x >> tr[i].y;
		tr[i].n = i;
		x[i] = y[i] = tr[i];
		used[i] = 0;
	}
	
	qsort(x, n, sizeof(point), compx);
	qsort(y, n, sizeof(point), compy);
	
	used[x[0].n] = 1;
	used[x[n-1].n] = 1;
	used[y[0].n] = 1;
	used[y[n-1].n] = 1;
    
    if ((x[1].n == y[1].n) || (x[1].n == y[n-2].n))
    {
    	used[x[1].n] = 1;
	}
    	
    if ((x[n-2].n == y[1].n) || (x[n-2].n == y[n-2].n))
    {
    	used[x[n-2].n] = 1;
	}
	
	int a = 0;
	
	for (int i = 0; i < n; i++)
	{
		if (used[i])
			a++;
	}
	
	cout << a << endl;
    
    return 0;
}
